//
/**************************************************************
	12F675(12F629)OSCCAL Monitor(beta version)
	(C) Air_variable 2006
	http://www.ne.jp/asahi/air/variable/
	version 0.30 October ,1 ,2006
**************************************************************/

#include <pic.h>
#include "delay.h"

#define	TEST_TONE  	116
//output port is

#define KEY_P		GPIO0 //
#define KEY_S		GPIO1 //
#define KEY_M		GPIO2 //

#define BUZZ_OUT	GPIO5 //
#define LED_OUT		GPIO4 //

#define EEP_ADR		0x00  // 0x00 to 0x7F
#define BACKUP_ADR	0x7F  // 0x00 to 0x7F

//see Configr -> Configuration Bits...
__CONFIG(0x3fc4);
char tone;

#pragma interrupt_level 1

//Timer Int process/
void interrupt toneset( void )
{
    TMR0 = tone;
	if (tone != 0){
		if (BUZZ_OUT)
			BUZZ_OUT=0;
		else
			BUZZ_OUT=1;
	}
	T0IF =0;
}

char epromset(adr,data)
{
	char tmp;
	do{
		eeprom_write(adr,data);
		while(WR);
		tmp=eeprom_read(adr);
	}while	(tmp!=data);
}

main(){
//Initialization
//Beep out is GPIO2, Power Hold is GPIO1
//Power Hold 1:Power is hold 0:Power is off
	OSCCAL 	= 0x80;
	GIE		= 0;		//Start of Interrupt service 
	OPTION 	= 0b00000010; // prescale 8 GPPU=0
    CMCON	= 7;
    ANSEL	= 0b00000000;//12F675
    TRISIO 	= 0b11001111;//
    GPIO	= 0b00000000;
	WPU		= 0b00000111;//Switch is all pull up
    TMR0	= 0x00 ;
    tone 	= TEST_TONE;//Set Test tone(440Hz)
	PEIE	= 1;		//peripheral Interrupt enable
	T0IE	= 1;		//Timer1 Interrupt enable
	LED_OUT	=1;
	DelayMs(250);
	if ((KEY_P==1) && (KEY_M==1)) OSCCAL = _READ_OSCCAL_DATA();//OSCCAL AUTO SET
	GIE		= 1;		//Start of Interrupt service 
	DelayMs(250);
	epromset(BACKUP_ADR, _READ_OSCCAL_DATA()); //Backup Orgnal Cal. data
	LED_OUT	=0;
	while(1){
		if (KEY_P==0) OSCCAL += 4;
		if (KEY_M==0) OSCCAL -= 4;
		if (KEY_S==0) {
			T0IE	= 0;
			LED_OUT	=1;
			epromset(EEP_ADR,OSCCAL);
			DelayMs(250);
			DelayMs(250);			
			LED_OUT=0;
			while (KEY_S==0);//key release check
			T0IE	= 1;
			
		}
		DelayMs(100);
	}
}
